
#pragma once

#include <winsock2.h>
#include <ws2tcpip.h>
#include <stdio.h>
#include "NatNetTypes.h"

typedef  void (*FUNC_CB)(int iLevel, char *szMessage);

/*
   NatNetHelper is a utility class providing networking and other helper functions
   that simplify working with NatNetServer and NatNetClient objects.
*/
class DLLCLASS NatNetHelper
{
public:
	static int GetAllOfMyAddresses(unsigned long Addresses[], int nMax);
	static int ProcessSocketError();
	static void GetSocketError(int iError, char* szOutMessage);
	static SOCKET Socket_CreateLargeMultiCast(in_addr MyAddress, int MyPort, in_addr MultiCastAddress);
	static int Broadcast(SOCKET sockfd, unsigned short uPort, char *Buffer, int nBytes);
	static int ConvertToIPAddress(char *szNameOrAddress, struct in_addr *Address);
	static SOCKET NatNetHelper::Socket_CreateForBroadcasting(unsigned long IP_Address, unsigned short uPort);
	static int NatNetVersion(unsigned char Version[4]);
	static int CopyFrame(const sFrameOfMocapData* pSrc, sFrameOfMocapData* pDst);
	static int FreeFrame(sFrameOfMocapData* pFrame);
	static int FreeBodyDefs(sMocapModels* pBodyDefs);
	static int SendToAddress(SOCKET sockfd, unsigned short uPort, in_addr IP_Address, char *Buffer, int nBytes);
	static int IPAddress_LongToString(unsigned long Address, char *str);
	static int GetIPs(unsigned long *Addresses, int nMax);
	static int IPAddress_StringToLong(char *szAddr, unsigned long *pAddress);
	static int SetErrorMsgHandlerFunc(void (*MyFunction)(int iLogLevel, char *szTraceMessage));
	static void TraceMessage(int iLevel, char *szMsg);
	static int InitializeWinsock();

	static int User_VerbosityLevel;
	
private:

	static bool bWinsockInitialized;
	static FUNC_CB CB_ErrorMsgHandler;
	//static void (*CB_ErrorMsgHandler)(int iLevel, char *szMessage);

};
